﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: false
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private streamer As AudioStreamer
	Public rp As RuntimePermissions
	Public SharedFolder As String
End Sub

Sub Service_Create
	SharedFolder = rp.GetSafeDirDefaultExternal("shared")
	
	streamer.Initialize("streamer", 8000, True, 16, streamer.VOLUME_MUSIC)
	streamer.StartPlaying
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	'StartServiceAt(Me,DateTime.Now + 2000,True) ' Relance de l'agent toutes les 2s
	'StartService(s1)
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	'StopService(Me)
End Sub

Public Sub Beep (DurationMs As Double, Frequency As Int)
	Dim sampleRate As Int = 8000
	Dim numSamples As Int = sampleRate * DurationMs / 1000
	Dim gsnd(2 * numSamples) As Byte
	For i = 0 To numSamples - 1
		Dim d As Double = Sin(2 * cPI * i / (sampleRate / Frequency))
		Dim val As Short = d * 32767
		gsnd(2 * i) = Bit.And(val, 0x00ff)
		gsnd(2 * i + 1) = Bit.UnsignedShiftRight(Bit.And(val, 0xff00), 8)
	Next
	streamer.Write(gsnd)
End Sub
'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
