﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
	
#End Region

Sub Process_Globals
	
	Type Message (Address As String, Body As String)
	Private Counter As Int = 0
	Dim Send_Sms As PhoneSms
	Dim str As ByteConverter
	Dim Access As String = "0000"
	Dim file_name As String="Setup.json"
	Dim Read_data As List
	Dim jg As JSONGenerator
	Dim JSON As JSONParser
	Dim GeneralAdmin As Map
	Dim GeneralAdmin_Data As Map
	Dim HostService As Map
	Dim HostService_Data As Map
	Dim AndroidAdmin_Data As Map
	Dim Guest_ident As Map
	Dim Guest_ident As Map
	Dim Guest_Data As Map
	Dim Guest_Book As Map
	Dim hg As PhoneEvents
	Dim Phone1,Active_Phone1,Phone2,Active_Phone2,ActivePhone1,ActivePhone2,Admin_Code,Admin_Message1,Admin_Message2,Localisation,Welcome_Message1,Welcome_Message2,Welcome_Message3 As String
	Dim Start_Date, Stop_Date, Start_Time, Stop_Time As Long
	Dim First_Name, Last_Name, Email, Phone, City, Door_Code,Battery_Level As String
	Dim Wifi_Enable, BLE_Enable As Boolean
	Dim Wifi As MLwifi
	
	Public admin As BluetoothAdmin
	Public BluetoothState As Boolean=True
	Public BluetoothState_off As Boolean=False
	Dim inst As Intent
	
	Dim RentalId As String
End Sub

Sub Service_Create
	
	' Load Setup
	Read_data.Initialize
	GeneralAdmin.Initialize
	GeneralAdmin_Data.Initialize
	HostService_Data.Initialize
	AndroidAdmin_Data.Initialize
	Guest_ident.Initialize
	Guest_Data.Initialize
	Guest_Book.Initialize
	Json_setup(False) 'Chargement du Setup
	'Service_Command("#Or001#%123456%dksf788815az%")
	
	
	'Initialise une instance Bluetooth pour gérer le on/off
	
	If inst.IsInitialized=False Then
		inst.Initialize("android.settings.BLUETOOTH_SETTINGS", "")
		StartActivity(inst)
	End If
	
		
	admin.Initialize("admin")
	
	
	hg.Initialize("hg")
End Sub

Sub Service_Start(startingIntent As Intent)
	
'	If Access="0000" Then
'		Wait For (Param.read_file_setup(file_name, Read_data)) complete (result As Boolean)
'	End If
	
	If startingIntent.Action = "android.provider.Telephony.SMS_RECEIVED" Then
		Dim messages() As Message
		messages = ParseSmsIntent(startingIntent)
		
		For i = 0 To messages.Length - 1
		
			'Dim FullMessage() As String = Regex.Split(",",messages(i))
			
			Dim Number As String = messages(i).Address' FullMessage(0).SubString(9)
			Dim mess As String = messages(i).Body 'FullMessage(1).SubString(6)
			
			'Dim In As Intent
			'Dim Number = "0123456789" As String
'			In.Initialize(In.ACTION_VIEW, "sms:" & Number)
'			In.PutExtra("sms_body", "Le portail va se déverrouiller à 3 reprises. Géraldine et François" & "vous souhaitent un excellent séjour.")
'			StartActivity(In)
			
			Service_Command(mess)
'			If mess = Access Then ' Access
'					
'				Dim text As String= "Le portail va se déverrouiller à 3 reprises. Géraldine et Francois vous souhaitent un excellent séjour."
'							
'				Send_Sms.Send(Number,text)
'				Counter=0
'				
'				Command(6) ' commande d'ouverture. Variable = nombre de pulse
'					
'			Else If mess.Contains("#" & Access & "#") Then 'Change Password
'				
'				Dim decode_message() As String= Regex.Split("#",mess)
'				Access=decode_message(2)
'					Log("Change Password")
'				Dim text As String= "Changement de code effectué. Nouveau Code: " & Access
'								
'				Send_Sms.Send(Number,text)
'					
'			End If
			
		
			Log(messages(i))
		Next
	End If
		
	Service.StopAutomaticForeground
End Sub

Private Sub Admin_StateChanged (NewState As Int, OldState As Int)
	Log("state changed: " & NewState)
	BluetoothState = NewState = admin.STATE_ON
	BluetoothState_off = NewState = admin.STATE_OFF
	
	If BluetoothState=True Then 'Lance le scan après avoir démarré le Bluetooth
		
	else If BluetoothState_off = True Then
		
	End If
	
End Sub

Sub Command(Nbre_Pulse As Int)
	
	' Envoi de la trame audio
	
	Do While Counter < Nbre_Pulse
		CallSub3(Starter, "Beep", 1000, 1000)
		Sleep(3000) 'Délai entre chaque pulse
		Counter= Counter+1
	Loop
	
End Sub

' Chargement Setup
Sub Json_setup(Mode As Boolean) 'False/True = Read/Write
	
	' Chargement du Setup
	
	' Genaral_Admin
		' Phone1
		' Active_Phone1
		' Phone2
		' Active_Phone2
		' Admin_Code
		' Admin_Message1
		' Admin_Message2
		' Localisation
	' Host_Service
		' Welcome_Message1
		' Welcome_Message2
		' Welcome_Message3
		
	If Mode=False Then
		JSON.Initialize(File.ReadString(File.DirDefaultExternal, "Setup.json"))
				
		GeneralAdmin = JSON.NextObject
				
		GeneralAdmin_Data=GeneralAdmin.Get("GeneralAdmin")
		HostService_Data=GeneralAdmin.Get("HostService")
		AndroidAdmin_Data=GeneralAdmin.Get("AndroidAdmin")
	
		Phone1=GeneralAdmin_Data.Get("Phone1")
		Phone2=GeneralAdmin_Data.Get("Phone2")
		Admin_Code=GeneralAdmin_Data.Get("Admin_Code")
		Admin_Message1=GeneralAdmin_Data.Get("Admin_Message1")
		Admin_Message2=GeneralAdmin_Data.Get("Admin_Message2")
		Localisation=GeneralAdmin_Data.Get("Localisation")
		Welcome_Message1=HostService_Data.Get("Welcome_Message1")
		Welcome_Message2=HostService_Data.Get("Welcome_Message2")
		Welcome_Message3=HostService_Data.Get("Welcome_Message3")
		ActivePhone1=GeneralAdmin_Data.Get("ActivePhone1")
		ActivePhone2=GeneralAdmin_Data.Get("ActivePhone2")
		Wifi_Enable=AndroidAdmin_Data.Get("Wifi")
		BLE_Enable=AndroidAdmin_Data.Get("BLE")
		Battery_Level=AndroidAdmin_Data.Get("BatteryLevel")
		
	Else If Mode=True Then
		
			
		Dim Host As Map
		Dim G_Admin As Map
		Dim Android_Admin As Map
		
		Host.Initialize
		Host.Put("Welcome_Message1", Welcome_Message1)
		Host.Put("Welcome_Message2", Welcome_Message2)
		Host.Put("Welcome_Message3", Welcome_Message3)
			
		G_Admin.Initialize
		G_Admin.Put("Phone1",Phone1)
		G_Admin.Put("ActivePhone1",ActivePhone1)
		G_Admin.Put("Phone2",Phone2)
		G_Admin.Put("ActivePhone2",ActivePhone2)
		G_Admin.Put("Admin_Code",Admin_Code)
		G_Admin.Put("Admin_Message1",Admin_Message1)
		G_Admin.Put("Admin_Message2",Admin_Message2)
		G_Admin.Put("Localisation",Localisation)
	
		Android_Admin.Initialize
		Android_Admin.Put("Wifi",Wifi_Enable)
		Android_Admin.Put("BLE",BLE_Enable)
		Android_Admin.Put("BatteryLevel",Battery_Level)
		
		jg.Initialize(CreateMap( "GeneralAdmin" :G_Admin,"HostService":Host,"AndroidAdmin":Android_Admin))
		
		File.WriteString(File.DirDefaultExternal,"Setup.json",jg.ToPrettyString(4))
	End If
	
		
		
		
	
End Sub

'Parses an SMS intent and returns an array of messages
Sub ParseSmsIntent (in As Intent) As Message()
	
	' Détection reception SMS et lecture
	Dim messages() As Message
	If in.HasExtra("pdus") = False Then Return messages
	Dim pdus() As Object
	Dim r As Reflector
	pdus = in.GetExtra("pdus")
	If pdus.Length > 0 Then
		Dim messages(pdus.Length) As Message
		For i = 0 To pdus.Length - 1
			r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
			messages(i).Body = r.RunMethod("getMessageBody")
			messages(i).Address = r.RunMethod("getOriginatingAddress")
		Next
	End If
	Return messages
End Sub

' Génération booking Host
Sub create_Host_JsonFile(Mode As Boolean) 'False/True = Read/Write
	
	
	If Mode=False Then
				
		JSON.Initialize(File.ReadString(File.DirDefaultExternal, RentalId & ".json"))
		
		Guest_ident = JSON.NextObject
		
		Guest_Data=Guest_ident.Get("Ref_Guest")
		RentalId=Guest_Data.Get("GuestId")
		First_Name=Guest_Data.Get("FirstName")
		Last_Name=Guest_Data.Get("LastName")
		Email=Guest_Data.Get("Email")
		Phone=Guest_Data.Get("Phone")
		City=Guest_Data.Get("City")
		Door_Code=Guest_Data.Get("DoorCode")
		
		Guest_Data=Guest_Book.Get("Reserved")
		Start_Date=Guest_Data.Get("StartDate")
		Start_Time=Guest_Data.Get("StartTime")
		Stop_Date=Guest_Data.Get("StopDate")
		Stop_Time=Guest_Data.Get("StopTime")
		
	Else If Mode=True Then
		
		' Creation de la réservation
				
		Dim Booking As Map
		Dim Ident_Loc As Map
		
		Booking.Initialize
		Booking.Put("StartDate", Start_Date)
		Booking.Put("StopDate", Stop_Date)
		Booking.Put("StartTime", Start_Time)
		Booking.Put("stopTime", Stop_Time)
	
		RentalId=Rnd(100000,999999)
	
		Do While File.Exists(File.DirDefaultExternal,RentalId & ".json")=True
			RentalId=Rnd(100000,999999)
		Loop
		
		Ident_Loc.Initialize
		Ident_Loc.Put("GuestId",RentalId)
		Ident_Loc.Put("FirstName",First_Name)
		Ident_Loc.Put("LastName",Last_Name)
		Ident_Loc.Put("Email",Email)
		Ident_Loc.Put("Phone",Phone)
		Ident_Loc.Put("City",City)
		Ident_Loc.Put("DoorCode",Door_Code)
		Ident_Loc.Put("Reserved",Booking)
	
		jg.Initialize(CreateMap( "Ref_Guest" :Ident_Loc))
	
		Log(jg.ToPrettyString(4))
	
		File.WriteString(File.DirDefaultExternal,RentalId & ".json",jg.ToPrettyString(4))
	End If
	
			
End Sub



' Traitement des ordres reçus
Sub Service_Command(Order As String)
	
	Dim Data As String=""
	Dim Header As String=""
	Dim Data_valid As Boolean=False
	Dim success_admin As Boolean=False
	Dim success_guest As Boolean=False
	
	Try
		If Order.SubString2(0,2)="#C" And Order.SubString(Order.Length-1)="%" Then 'Identifie une trame
			
			' Description des ordres
			Dim Ident_Header() As String=Regex.Split("#",Order)
			Dim Datas_Header As String=Order.SubString(5)
			Dim Data_Header() As String=Regex.Split("#",Datas_Header)
			Dim Nbre_Header As Int=Ident_Header(1).SubString(1)
	
			If Nbre_Header<>Data_Header.Length Then
				
				Send_Succesful_Command(Phone1,"Command Fail")
		
			Else
		
				For Each Header_Item As String In Data_Header
					'If Header_Item<> Data_Header(1) Then 'Exclus la première entête
			
					'Or004%0612484116%
					'Or014%%
			
					' Vérification validité de la trame
					If Header_Item.SubString2(5,6)="%"  And  Order.SubString(Order.Length-1)="%" Then
						Header = Header_Item.SubString2(0,5)
						Data = Header_Item.SubString2(6,Header_Item.Length-1)
						Data_valid=True
					End If
					'End If
		
					If Data_valid=True Then
		
						If Header.SubString2(0,2)="Or" Then 'Admin Command
							success_admin=True
							Select Case Header
				
								' Admin Command
				
								Case "Or001"
									Dim D_password() As String= Regex.Split("%",Data)
									If D_password(0)=Admin_Code Then
										Admin_Code = D_password(1)
										
										Send_Succesful_Command(Phone1,"Successful New Code ")
									End If
					
								Case "Or002"
									Dim D_Phone1() As String= Regex.Split("%",Data)
									Phone1=D_Phone1(0)
							
								Case "Or003"
									Dim D_ActivePhone1() As String= Regex.Split("%",Data)
									Active_Phone1=D_ActivePhone1(0)
							
								Case "Or004"
									Dim D_Phone2() As String= Regex.Split("%",Data)
									Phone2=D_Phone2(0)
						
								Case "Or005"
									Dim D_ActivePhone2() As String= Regex.Split("%",Data)
									Active_Phone2=D_ActivePhone2(0)
					
								Case "Or006"
									Dim D_Admin_Message1() As String= Regex.Split("%",Data)
									Admin_Message1=D_Admin_Message1(0)
						
								Case "Or007"
									Dim D_Admin_Message2() As String= Regex.Split("%",Data)
									Admin_Message2=D_Admin_Message2(0)
								Case "Or008"
									Dim D_Localisation() As String= Regex.Split("%",Data)
									Localisation=D_Localisation(0)
					
								Case "Or009"
									Dim D_Welcome_Message1() As String= Regex.Split("%",Data)
									Welcome_Message1=D_Welcome_Message1(0)
						
								Case "Or010"
									Dim D_Welcome_Message2() As String= Regex.Split("%",Data)
									Welcome_Message2=D_Welcome_Message2(0)
						
								Case "Or011"
									Dim D_Welcome_Message3() As String= Regex.Split("%",Data)
									Welcome_Message3=D_Welcome_Message3(0)
						
								Case "Or012"
									
									'ACtivation du wifi
									Dim D_Wifi_Enable() As String= Regex.Split("%",Data)
									Wifi_Enable = (D_Wifi_Enable(0))
									Wifi.EnableWifi(Wifi_Enable)
						
								Case "Or013"
									'Activation Bluetooth
									Dim D_BLE_Enable() As String= Regex.Split("%",Data)
									BLE_Enable=D_BLE_Enable(0)
									
									If BLE_Enable=True Then
										admin.Enable
									Else
										admin.Disable	
									End If
									
								Case "Or014"
									'Return the battery Level
									Send_Succesful_Command(Phone1,"Battery Level: " & Battery_Level & "%")
									
								Case "Or015"
								
							End Select
				
						Else if Header.SubString2(0,3)="#Hb" Then 'Host Command
							success_guest=True
							Select Case Header
			
								' Booking Command
				
								Case "Hb001"
									Dim D_First_Name() As String= Regex.Split("%",Data)
									First_Name=D_First_Name(0)
				
								Case "Hb002"
									Dim D_last_Name() As String= Regex.Split("%",Data)
									Last_Name=D_last_Name(0)
								Case "Hb003"
									Dim D_Email() As String= Regex.Split("%",Data)
									Email=D_Email(0)
									
								Case "Hb004"
									Dim D_Phone() As String= Regex.Split("%",Data)
									Phone=D_Phone(0)
									
								Case "Hb005"
									Dim D_City() As String= Regex.Split("%",Data)
									City=D_City(0)
									
								Case "Hb006"
									Dim D_Door_Code() As String= Regex.Split("%",Data)
									Door_Code=D_Door_Code(0)
									
								Case "Hb007"
									Dim D_Start_Date() As String= Regex.Split("%",Data)
									Start_Date=D_Start_Date(0)
									
								Case "Hb008"
									Dim D_Start_Time() As String= Regex.Split("%",Data)
									Start_Time=D_Start_Time(0)
									
								Case "Hb009"
									Dim D_Stop_Date() As String= Regex.Split("%",Data)
									Stop_Date=D_Stop_Date(0)
									
								Case "Hb010"
									Dim D_Stop_Time() As String= Regex.Split("%",Data)
									Stop_Time=D_Stop_Time(0)
									
								Case "Hb011"
				
								Case "Hb012"
						
				
							End Select
						End If
					End If
				Next
		
				If Data_valid=True Then
					If success_admin=True Then
						Send_Succesful_Command(Phone1,Nbre_Header & " Successful Commands")
						Json_setup(True) 'Sauvegarde du Setup
					Else if success_guest=True Then
						Send_Succesful_Command(Phone1,Nbre_Header & " Successful Commands")
						create_Host_JsonFile(True) 'Création du fichier invité
					End If
					
				End If
		
			End If
		End If
		
	Catch
		Log(LastException)
	End Try
	
		
'	If  Order.SubString2(0,2)="#C" Then 'détection multiple commande 
'		Dim Data_Header() As String=Regex.Split("#",Order)
'		Dim Nbre_Header As Int=Data_Header(0).SubString(1)
'	
'	Else
'		' Vérification validité de la trame (Simple Command)
'		If Order.SubString2(0,1)="#" And Order.SubString2(6,7)="#" And  Order.SubString2(0,1)="#" And Order.SubString2(7,8)="%" And  Order.SubString(Order.Length-1)="%" Then
'			Header = Order.SubString2(0,7)
'			Data = Order.SubString2(8,Order.Length-1)
'			Data_valid=True
'		End If
'		
'	End If
	
	
	
	
	
		
End Sub

Sub hg_BatteryChanged (Level As Int, Scale As Int, Plugged As Boolean, Intent As Intent)
	Battery_Level=Level
End Sub

Sub Send_Succesful_Command(Number As String,message As String)
	
	Send_Sms.Send(Number,message)
End Sub

Sub Service_Destroy

End Sub